# Flower Knight Girl API Proxy

## Description

This is a proxy for DMM's version of Flower Knight Girl. Currently its main feature is providing a way to use parts of Nutaku's translations (or user-provided translations) in the DMM version.

## Dependencies

* A D compiler
* dub
* fish (for generating translation data)
* csvquote (for generating translation data)

## Translations

To use the proxy for translations based on the Nutaku version, you need to generate the data from the Nutaku version's master data. You can do this by following these steps:
0. Install [fish](https://fishshell.com/) and [csvquote](https://github.com/dbro/csvquote)
1. Save the /master/getMaster API response of the Nutaku version
2. Decompress the response (zlib) and name the file 'nutakuMaster.json'
3. Run `./generate-translations.fish`
4. Verify the translations were generated correctly by looking at the output of `head data/*`

## Building

1. Copy `source/config.d.example` to `source/config.d` and edit it
2. Run `dub build`

## Using

1. Start the proxy (`./fkg-api-proxy`)
2. Make your browser send the API requests through the proxy (e.g. by adding an /etc/hosts entry)

## Disclaimer

This is most likely against DMM's ToS. Use at your own risk. That said, it should be unlikely that you'd get banned for using this, since it shouldn't be detectable from DMM's side.
